/* Decrypt file using DES */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include "deslib/des.h"

#define BUFSIZE	8192

void usage();

int main(int argc, char *argv[])
{
	int   ptext, ctext;
	char  keystr[1025], ivecstr[1025];
	char  bufin[BUFSIZE], bufout[BUFSIZE];
	int   datalen, num;
	
	des_cblock key, ivec;
	des_key_schedule ks;
      
	if (argc != 3) {
		printf("usage: %s [src filename] [dest filename]\n", argv[0]);
		exit(1);
	}

	fprintf(stderr, "Key: ");
	fgets(keystr, sizeof(keystr), stdin);  	


	if ( ( ptext = open(argv[1], O_RDONLY) ) < 0) {
		fprintf(stderr, "%s: error opening file.\n", argv[1]);
		exit(1);
	}

	if ( (ctext = open(argv[2], O_WRONLY | O_CREAT, 00600) ) < 0) {
  		fprintf(stderr, "%s: cannot create.\n", argv[1]);
  		exit(1);
  	}
	
	des_string_to_2keys(keystr, &key, &ivec);
	des_set_key(&key, ks);
	num = 0;
            
        while ( ( datalen = read(ptext, bufin, BUFSIZE) ) > 0 ) {
        	des_cfb64_encrypt(bufin, bufout, datalen,
        				ks, &ivec, &num, DES_DECRYPT);
                write(ctext, bufout, datalen);
        }
        
        close(ptext);
        close(ctext);
      
}

